﻿#undef debugTestUapi
#define debugTestUapi

using CySmart.Common.Base.Compatibility.Net20;
using CySmart.DongleCommunicator.API;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace Host
{
    public static class Rfdb
    {
        // First, define the overall dialog box itself
        private static Form rfdbBox;
        private static TableLayoutPanel panel;
        // Common parameters
        private static Label commonLabel;
        private static TableLayoutPanel common;
        private static Label dstIeeeAddrLabel;
        private static TextBox dstIeeeAddr;
        private static Label appCapsLabel;
        private static TextBox appCaps;
        private static Label devTypeListLabel;
        private static TextBox devTypeList;
        private static Label profileIDListLabel;
        private static TextBox profileIDList;
        private static Label destPanIDLabel;
        private static TextBox destPanID;
        private static Label destNwkAddrLabel;
        private static TextBox destNwkAddr;
        private static Label rcuNodeCapsLabel;
        private static TextBox rcuNodeCaps;
        private static Label rcuVendorIDLabel;
        private static TextBox rcuVendorID;
        private static Label rcuVendorStringLabel;
        private static TextBox rcuVendorString;
        private static Label srchDevTypeLabel;
        private static TextBox srchDevType;
        private static Label discProfileIDListSizeLabel;
        private static TextBox discProfileIDListSize;
        private static Label discProfileIDListLabel;
        private static TextBox discProfileIDList;
        private static Label discDurationLabel;
        private static TextBox discDuration;
        private static Label keyExchCntLabel;
        private static TextBox keyExchCnt;
        private static Label discRepIntLabel;
        private static TextBox discRepInt;
        private static Label maxDiscRepsLabel;
        private static TextBox maxDiscReps;
        private static Label maxRepNodesLabel;
        private static TextBox maxRepNodes;
        private static Label userStrLabel;
        private static TextBox userStr;
        private static Label keyRepIntLabel;
        private static TextBox keyRepInt;
        private static Label numKeyMapsLabel;
        private static TextBox numKeyMaps;
        private static Label keyMapLabel;
        private static TextBox keyMap;
        private static Label actPerLabel;
        private static TextBox actPer;
        private static Label dutyCycleLabel;
        private static TextBox dutyCycle;
        private static Label irPairInfoLabel;
        private static TextBox irPairInfo;
        private static Label discTimeoutLabel;
        private static TextBox discTimeout;
        private static Label maxDiscReportsLabel;
        private static TextBox maxDiscReports;
        // ZRC1.1-only parameters
        private static Label zrc11Label;
        private static TableLayoutPanel zrc11;
        private static Label cmdDiscReqLabel;
        private static TextBox cmdDiscReq;
        // ZRC2.0-only parameters
        private static Label zrc20Label;
        private static TableLayoutPanel zrc20;
        private static Label vendorIDFilterLabel;
        private static TextBox vendorIDFilter;
        private static Label minMaxClassFilterLabel;
        private static TextBox minMaxClassFilter;
        private static Label minLqiFilterLabel;
        private static TextBox minLqiFilter;
        private static Label gdpCapsLabel;
        private static TextBox gdpCaps;
        private static Label pollConstsLabel;
        private static TextBox pollConsts;
        private static Label bindOrigValidTimeLabel;
        private static TextBox bindOrigValidTime;
        private static Label idCapsLabel;
        private static TextBox idCaps;
        private static Label zrcProCapsLabel;
        private static TextBox zrcProCaps;
        private static Label actBanksSuppTxLabel;
        private static TextBox actBanksSuppTx;
        private static Label numIrdbVendorsLabel;
        private static TextBox numIrdbVendors;
        private static Label irdbVendorSuppLabel;
        private static TextBox irdbVendorSupp;
        private static Label actBanksVerLabel;
        private static TextBox actBanksVer;
        private static Label actCodesSuppTxLabel;
        private static TextBox actCodesSuppTx;
        private static Label numMapActsLabel;
        private static TextBox numMapActs;
        private static Label mapActsLabel;
        private static TextBox mapActs;
        private static Label numHaInstLabel;
        private static TextBox numHaInst;
        private static Label haSuppLabel;
        private static TextBox haSupp;
        // MSO-only parameters
        private static Label msoLabel;
        private static TableLayoutPanel mso;
        private static Label respWaitTimeLabel;
        private static TextBox respWaitTime;
        private static Label bindCfgLabel;
        private static TextBox bindCfg;
        private static Label bindInitIndLabel;
        private static TextBox bindInitInd;
        private static Label getValCfgLabel;
        private static TextBox getValCfg;
        // MSO & ZRC2.0 parameters
        private static Label zrc20MsoLabel;
        private static TableLayoutPanel zrc20Mso;
        private static Label maxBindCandsLabel;
        private static TextBox maxBindCands;
        private static Label autoCheckValLabel;
        private static TextBox autoCheckVal;
        private static Label linkLostWaitTimeLabel;
        private static TextBox linkLostWaitTime;
        // ESP-only parameters
        private static Label espLabel;
        private static TableLayoutPanel esp;
        private static Label tvNumLabel;
        private static TextBox tvNum;
        // A collection of labels that facilitates search and classification
        private static List<Label> paramLabels;
        // A collection of text boxes that facilitates search and classification
        private static List<TextBox> paramBoxes;
        // The usual 'Ok' and 'Cancel' window buttons
        private static Button ok;
        private static Button cancel;

        private static Form slotBox;
        private static TableLayoutPanel slotPanel;
        private static Label slotIndexLabel;
        private static TextBox slotIndex;
        private static Button slotOk;
        private static Button slotCancel;

        private static Constants.profileFlags profileID = Constants.profileFlags.ZRC20;

        private class rfdbConfigObject : Object
        {
            public byte idx { get; set; }
            public int len { get; set; }
            public int maxLen { get; set; }
            public bool changed { get; set; }
            public bool required { get; set; }
            public bool supported { get; set; }
            public Constants.profileFlags profiles { get; set; }
            public byte[] zrc11Def { get; set; }
            public byte[] zrc20Def { get; set; }
            public byte[] msoDef { get; set; }
            public byte[] espDef { get; set; }
            public byte[] value { get; set; }
            public rfdbConfigObject(byte index, int length, int maxLength, Constants.profileFlags profileUsage, byte[] zrc11DefValue, byte[] zrc20DefValue, byte[] msoDefValue, byte[] espDefValue)
            {
                idx = index;
                maxLen = maxLength;
                len = length;
                profiles = profileUsage;
                changed = false;
                required = false;
                supported = true;
                zrc11Def = zrc11DefValue;
                zrc20Def = zrc20DefValue;
                msoDef = msoDefValue;
                espDef = espDefValue;
            }
            public rfdbConfigObject(byte index, Constants.profileFlags profileUsage, byte zrc11DefValue, byte zrc20DefValue, byte msoDefValue, byte espDefValue)
            {
                idx = index;
                maxLen = 0;
                len = 1;
                profiles = profileUsage;
                changed = false;
                required = false;
                supported = true;
                zrc11Def = new byte[1] { zrc11DefValue };
                zrc20Def = new byte[1] { zrc20DefValue };
                msoDef = new byte[1] { msoDefValue };
                espDef = new byte[1] { espDefValue };
            }
            public rfdbConfigObject(byte index, Constants.profileFlags profileUsage, ushort zrc11DefValue, ushort zrc20DefValue, ushort msoDefValue, ushort espDefValue)
            {
                idx = index;
                maxLen = 0;
                len = 2;
                profiles = profileUsage;
                changed = false;
                required = false;
                supported = true;
                zrc11Def = BitConverter.GetBytes(zrc11DefValue);
                zrc20Def = BitConverter.GetBytes(zrc20DefValue);
                msoDef = BitConverter.GetBytes(msoDefValue);
                espDef = BitConverter.GetBytes(espDefValue);
            }
            public rfdbConfigObject(byte index, Constants.profileFlags profileUsage, uint zrc11DefValue, uint zrc20DefValue, uint msoDefValue, uint espDefValue)
            {
                idx = index;
                maxLen = 0;
                len = 4;
                profiles = profileUsage;
                changed = false;
                required = false;
                supported = true;
                zrc11Def = BitConverter.GetBytes(zrc11DefValue);
                zrc20Def = BitConverter.GetBytes(zrc20DefValue);
                msoDef = BitConverter.GetBytes(msoDefValue);
                espDef = BitConverter.GetBytes(espDefValue);
            }
            public rfdbConfigObject(byte index, Constants.profileFlags profileUsage, ulong zrc11DefValue, ulong zrc20DefValue, ulong msoDefValue, ulong espDefValue)
            {
                idx = index;
                maxLen = 0;
                len = 8;
                profiles = profileUsage;
                changed = false;
                required = false;
                supported = true;
                zrc11Def = BitConverter.GetBytes(zrc11DefValue);
                zrc20Def = BitConverter.GetBytes(zrc20DefValue);
                msoDef = BitConverter.GetBytes(msoDefValue);
                espDef = BitConverter.GetBytes(espDefValue);
            }
        }

        static Rfdb()
        {
            ////////////////////////////////////////////////////////////////////
            // First, define the overall dialog box itself
            ////////////////////////////////////////////////////////////////////
            rfdbBox = new Form();
            rfdbBox.Name = "rfdbBox";
            rfdbBox.Width = 800;
            rfdbBox.Height = 907;   // This is equal to the sum of the absolute row heights in the main table layout
                                    //  panel below (870 pixels), plus the standard Windows bottom frame height of 8 pixels
                                    //  and the standard Windows title bar height of 29 pixels. I measured these myself!!!
            rfdbBox.Icon = Program.mf.Icon;
            rfdbBox.FormBorderStyle = FormBorderStyle.FixedDialog;
            rfdbBox.MaximizeBox = false;
            rfdbBox.MinimizeBox = false;

            // This is the main layout panel, which will be subdivided into groups of parameters. Each group will comprise
            //  a label and a sub layout panel, with the parameter labels and text boxes populating the sub panels
            panel = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.None,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "paramControls",
                RowCount = 9
            };

            panel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            panel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            // The height of each text box will default to 20 pixels, plus a margin of 3 pixels at the top and also at the
            //  bottom, so the overall text box height is 26. Table layout panels use 3 pixels to separate the rows (at
            //  least when FormBorderStyle is 'FixedDialog') as well as 3 pixels before the first row and 3 pixels after
            //  the last row. Therefore, a sub layout panel with 'n' rows (each containing a text box) will be
            //  n*(26 + 3) + 3 pixels in height, which is the value we set here for each row of the main layout panel.
            //  The Buttons at the bottom default to 23 pixels high plus 3 pixels above and below, so their overall row
            //  height is 29 pixels. The group labels use the default label height of 13 pixels, with no margins above
            //  or below, so they easily fit within a row height of 26 (which matches the overall text box height).
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 17*(26+3) + 3));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 4*(26+3) + 3));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 3*(26+3) + 3));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26+3 + 3));
            panel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 29));

            ////////////////////////////////////////////////////////////////////
            // Common parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            commonLabel = new Label()
            {
                Text = "Common",
                TextAlign = ContentAlignment.MiddleLeft
            };
            commonLabel.Font = new Font(commonLabel.Font, FontStyle.Bold);

            common = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "commonParams",
                RowCount = 26,
                Margin = new Padding(3, 0, 3, 0)
            };
            common.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            common.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            for (int i = 0; i < 26; i++)
            {
                common.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            }

            // 26 parameters will populate this group's layout panel, each with a label and a text box
            dstIeeeAddrLabel = new Label()
            {
                Text = "Destination IEEE Address"
            };
            dstIeeeAddr = new TextBox()
            {
                Tag = new rfdbConfigObject(0, Constants.profileFlags.COMMON, 0x00UL, 0x00UL, 0x00UL, 0x00UL)
            };
            dstIeeeAddr.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(dstIeeeAddrLabel, 0, 0);
            common.Controls.Add(dstIeeeAddr, 1, 0);

            appCapsLabel = new Label()
            {
                Text = "Application Capabilities"
            };
            appCaps = new TextBox()
            {
                Tag = new rfdbConfigObject(1, Constants.profileFlags.COMMON, 0x12, 0x22, 0x12, 0x12)
            };
            ((rfdbConfigObject)appCaps.Tag).required = true;
            appCaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(appCapsLabel, 0, 1);
            common.Controls.Add(appCaps, 1, 1);

            devTypeListLabel = new Label()
            {
                Text = "Device Type List"
            };
            devTypeList = new TextBox()
            {
                Tag = new rfdbConfigObject(2, 1, 3, Constants.profileFlags.COMMON,
                                           new byte[3] { 0x01, 0x00, 0x00 }, new byte[3] { 0x01, 0x00, 0x00 },
                                           new byte[3] { 0x01, 0x00, 0x00 }, new byte[3] { 0x01, 0x00, 0x00 })
            };
            ((rfdbConfigObject)devTypeList.Tag).required = true;
            devTypeList.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(devTypeListLabel, 0, 2);
            common.Controls.Add(devTypeList, 1, 2);

            profileIDListLabel = new Label()
            {
                Text = "Profile ID List"
            };
            profileIDList = new TextBox()
            {
                Tag = new rfdbConfigObject(3, 2, 7, Constants.profileFlags.COMMON,
                                           new byte[7] { 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0x01, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 })
            };
            ((rfdbConfigObject)profileIDList.Tag).required = true;
            profileIDList.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveProfileValue);
            common.Controls.Add(profileIDListLabel, 0, 3);
            common.Controls.Add(profileIDList, 1, 3);

            destPanIDLabel = new Label()
            {
                Text = "Destination PAN ID"
            };
            destPanID = new TextBox()
            {
                Tag = new rfdbConfigObject(4, Constants.profileFlags.COMMON, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF)
            };
            destPanID.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(destPanIDLabel, 0, 4);
            common.Controls.Add(destPanID, 1, 4);

            destNwkAddrLabel = new Label()
            {
                Text = "Destination Network Address"
            };
            destNwkAddr = new TextBox()
            {
                Tag = new rfdbConfigObject(5, Constants.profileFlags.COMMON, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF)
            };
            destNwkAddr.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(destNwkAddrLabel, 0, 5);
            common.Controls.Add(destNwkAddr, 1, 5);

            rcuNodeCapsLabel = new Label()
            {
                Text = "RCU Node Capabilities"
            };
            rcuNodeCaps = new TextBox()
            {
                Tag = new rfdbConfigObject(6, Constants.profileFlags.COMMON, 0x0C, 0x0C, 0x0C, 0x0C)
            };
            rcuNodeCaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(rcuNodeCapsLabel, 0, 6);
            common.Controls.Add(rcuNodeCaps, 1, 6);

            rcuVendorIDLabel = new Label()
            {
                Text = "RCU Vendor ID"
            };
            rcuVendorID = new TextBox()
            {
                Tag = new rfdbConfigObject(7, Constants.profileFlags.COMMON, 0x10EF, 0x10EF, 0x10EF, 0x10EF)
            };
            rcuVendorID.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(rcuVendorIDLabel, 0, 7);
            common.Controls.Add(rcuVendorID, 1, 7);

            rcuVendorStringLabel = new Label()
            {
                Text = "RCU Vendor String"
            };
            rcuVendorString = new TextBox()
            {
                Tag = new rfdbConfigObject(8, 7, 7, Constants.profileFlags.COMMON,
                                           Encoding.ASCII.GetBytes("UEI    "), Encoding.ASCII.GetBytes("UEI    "),
                                           Encoding.ASCII.GetBytes("UEI    "), Encoding.ASCII.GetBytes("UEI    "))
            };
            rcuVendorString.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveStringValue);
            common.Controls.Add(rcuVendorStringLabel, 0, 8);
            common.Controls.Add(rcuVendorString, 1, 8);

            srchDevTypeLabel = new Label()
            {
                Text = "Search Device Type"
            };
            srchDevType = new TextBox()
            {
                Tag = new rfdbConfigObject(9, Constants.profileFlags.COMMON, 0xFF, 0xFF, 0xFF, 0xFF)
            };
            srchDevType.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(srchDevTypeLabel, 0, 9);
            common.Controls.Add(srchDevType, 1, 9);

            discProfileIDListSizeLabel = new Label()
            {
                Text = "Discovery Profile ID List Size"
            };
            discProfileIDListSize = new TextBox()
            {
                Tag = new rfdbConfigObject(10, Constants.profileFlags.COMMON, 0x01, 0x02, 0x01, 0x01)
            };
            discProfileIDListSize.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(discProfileIDListSizeLabel, 0, 10);
            common.Controls.Add(discProfileIDListSize, 1, 10);

            discProfileIDListLabel = new Label()
            {
                Text = "Discovery Profile ID List"
            };
            discProfileIDList = new TextBox()
            {
                Tag = new rfdbConfigObject(11, 2, 7, Constants.profileFlags.COMMON,
                                           new byte[7] { 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0x01, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
                                           new byte[7] { 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 })
            };
            discProfileIDList.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(discProfileIDListLabel, 0, 11);
            common.Controls.Add(discProfileIDList, 1, 11);

            discDurationLabel = new Label()
            {
                Text = "Discovery Duration"
            };
            discDuration = new TextBox()
            {
                Tag = new rfdbConfigObject(12, Constants.profileFlags.COMMON, 6250U, 6250U, 6250U, 6250U)
            };
            discDuration.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(discDurationLabel, 0, 12);
            common.Controls.Add(discDuration, 1, 12);

            keyExchCntLabel = new Label()
            {
                Text = "Key Exchange Count"
            };
            keyExchCnt = new TextBox()
            {
                Tag = new rfdbConfigObject(13, Constants.profileFlags.COMMON, 0x24, 0x03, 0x04, 0x05)
            };
            keyExchCnt.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(keyExchCntLabel, 0, 13);
            common.Controls.Add(keyExchCnt, 1, 13);

            discRepIntLabel = new Label()
            {
                Text = "Discovery Repetition Interval"
            };
            discRepInt = new TextBox()
            {
                Tag = new rfdbConfigObject(14, Constants.profileFlags.COMMON, 62500U, 31250U, 37500U, 12500U)
            };
            discRepInt.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(discRepIntLabel, 0, 14);
            common.Controls.Add(discRepInt, 1, 14);

            maxDiscRepsLabel = new Label()
            {
                Text = "Maximum Discovery Repetitions"
            };
            maxDiscReps = new TextBox()
            {
                Tag = new rfdbConfigObject(15, Constants.profileFlags.COMMON, 0x1E, 0x02, 0x02, 0x01)
            };
            maxDiscReps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(maxDiscRepsLabel, 0, 15);
            common.Controls.Add(maxDiscReps, 1, 15);

            maxRepNodesLabel = new Label()
            {
                Text = "Maximum Reported Nodes"
            };
            maxRepNodes = new TextBox()
            {
                Tag = new rfdbConfigObject(16, Constants.profileFlags.COMMON, 0x01, 0xFF, 0x10, 0x03)
            };
            maxRepNodes.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(maxRepNodesLabel, 0, 16);
            common.Controls.Add(maxRepNodes, 1, 16);

            userStrLabel = new Label()
            {
                Text = "User String"
            };
            userStr = new TextBox()
            {
                Tag = new rfdbConfigObject(17, 15, 15, Constants.profileFlags.COMMON,
                                           Encoding.ASCII.GetBytes("UEI RFDB       "), Encoding.ASCII.GetBytes("UEI RFDB       "),
                                           Encoding.ASCII.GetBytes("UEI RFDB       "), Encoding.ASCII.GetBytes("UEI RFDB       "))
            };
            userStr.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveStringValue);
            common.Controls.Add(userStrLabel, 0, 17);
            common.Controls.Add(userStr, 1, 17);

            keyRepIntLabel = new Label()
            {
                Text = "Key Repeat Interval"
            };
            keyRepInt = new TextBox()
            {
                Tag = new rfdbConfigObject(18, Constants.profileFlags.COMMON, (ushort)50, (ushort)100, (ushort)60, (ushort)100)
            };
            keyRepInt.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(keyRepIntLabel, 0, 18);
            common.Controls.Add(keyRepInt, 1, 18);

            numKeyMapsLabel = new Label()
            {
                Text = "Number of Key Mappings"
            };
            numKeyMaps = new TextBox()
            {
                Tag = new rfdbConfigObject(19, Constants.profileFlags.COMMON, 30, 30, 30, 30)
            };
            ((rfdbConfigObject)numKeyMaps.Tag).supported = false;
            numKeyMaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(numKeyMapsLabel, 0, 19);
            common.Controls.Add(numKeyMaps, 1, 19);

            keyMapLabel = new Label()
            {
                Text = "Key Map"
            };
            keyMap = new TextBox()
            {
                Tag = new rfdbConfigObject(20, Constants.profileFlags.COMMON, 0, 0, 0, 0) // To be assigned dynamically
            };
            ((rfdbConfigObject)keyMap.Tag).supported = false;
            keyMap.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(keyMapLabel, 0, 20);
            common.Controls.Add(keyMap, 1, 20);

            actPerLabel = new Label()
            {
                Text = "Active Period"
            };
            actPer = new TextBox()
            {
                Tag = new rfdbConfigObject(21, Constants.profileFlags.COMMON, 1050U, 1050U, 1050U, 1050U)
            };
            actPer.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(actPerLabel, 0, 21);
            common.Controls.Add(actPer, 1, 21);

            dutyCycleLabel = new Label()
            {
                Text = "Duty Cycle"
            };
            dutyCycle = new TextBox()
            {
                Tag = new rfdbConfigObject(22, Constants.profileFlags.COMMON, 0x00U, 0x00U, 0x00U, 0x00U)
            };
            dutyCycle.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(dutyCycleLabel, 0, 22);
            common.Controls.Add(dutyCycle, 1, 22);

            irPairInfoLabel = new Label()
            {
                Text = "IR Pairing Info"
            };
            irPairInfo = new TextBox()
            {
                Tag = new rfdbConfigObject(23, Constants.profileFlags.COMMON, 0, 0, 0, 0) // To be assigned dynamically
            };
            ((rfdbConfigObject)irPairInfo.Tag).supported = false;
            irPairInfo.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(irPairInfoLabel, 0, 23);
            common.Controls.Add(irPairInfo, 1, 23);

            discTimeoutLabel = new Label()
            {
                Text = "Discovery Timeout"
            };
            discTimeout = new TextBox()
            {
                Tag = new rfdbConfigObject(24, Constants.profileFlags.COMMON, 5000U, 5000U, 5000U, 5000U)
            };
            discTimeout.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(discTimeoutLabel, 0, 24);
            common.Controls.Add(discTimeout, 1, 24);

            maxDiscReportsLabel = new Label()
            {
                Text = "Maximum Discovery Reports"
            };
            maxDiscReports = new TextBox()
            {
                Tag = new rfdbConfigObject(25, Constants.profileFlags.COMMON, 8, 8, 8, 8)
            };
            maxDiscReports.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            common.Controls.Add(maxDiscReportsLabel, 0, 25);
            common.Controls.Add(maxDiscReports, 1, 25);

            panel.Controls.Add(commonLabel, 0, 0);
            panel.Controls.Add(common, 0, 1);
            panel.SetRowSpan(common, 5);

            ////////////////////////////////////////////////////////////////////
            // ZRC1.1-only parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            zrc11Label = new Label()
            {
                Text = "ZRC1.1 Only",
                TextAlign = ContentAlignment.MiddleLeft
            };
            zrc11Label.Font = new Font(zrc11Label.Font, FontStyle.Bold);

            zrc11 = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "zrc11Params",
                RowCount = 1,
                Margin = new Padding(3, 0, 3, 0)
            };
            zrc11.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            zrc11.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            zrc11.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));

            // Only 1 parameter will populate this group's layout panel, with a label and a text box
            cmdDiscReqLabel = new Label()
            {
                Text = "Command Discovery Required"
            };
            cmdDiscReq = new TextBox()
            {
                Tag = new rfdbConfigObject(46, Constants.profileFlags.ZRC11, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)cmdDiscReq.Tag).supported = false;
            cmdDiscReq.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc11.Controls.Add(cmdDiscReqLabel, 0, 0);
            zrc11.Controls.Add(cmdDiscReq, 1, 0);

            panel.Controls.Add(zrc11Label, 0, 6);
            panel.Controls.Add(zrc11, 0, 7);

            ////////////////////////////////////////////////////////////////////
            // ZRC2.0-only parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            zrc20Label = new Label()
            {
                Text = "ZRC2.0 Only",
                TextAlign = ContentAlignment.MiddleLeft
            };
            zrc20Label.Font = new Font(zrc20Label.Font, FontStyle.Bold);

            zrc20 = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "zrc20Params",
                RowCount = 17,
                Margin = new Padding(3, 0, 3, 0)
            };
            zrc20.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            zrc20.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            for (int i = 0; i < 17; i++)
            {
                zrc20.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            }

            // 17 parameters will populate this group's layout panel, each with a label and a text box
            vendorIDFilterLabel = new Label()
            {
                Text = "Vendor ID Filter"
            };
            vendorIDFilter = new TextBox()
            {
                Tag = new rfdbConfigObject(29, Constants.profileFlags.ZRC20, 0, 0xFFFF, 0, 0)
            };
            vendorIDFilter.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(vendorIDFilterLabel, 0, 0);
            zrc20.Controls.Add(vendorIDFilter, 1, 0);

            minMaxClassFilterLabel = new Label()
            {
                Text = "Min/Max Class Filter"
            };
            minMaxClassFilter = new TextBox()
            {
                Tag = new rfdbConfigObject(30, Constants.profileFlags.ZRC20, 0, 0xE0, 0, 0)
            };
            minMaxClassFilter.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(minMaxClassFilterLabel, 0, 1);
            zrc20.Controls.Add(minMaxClassFilter, 1, 1);

            minLqiFilterLabel = new Label()
            {
                Text = "Minimum LQI Filter"
            };
            minLqiFilter = new TextBox()
            {
                Tag = new rfdbConfigObject(31, Constants.profileFlags.ZRC20, 0, 0x00, 0, 0)
            };
            minLqiFilter.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(minLqiFilterLabel, 0, 2);
            zrc20.Controls.Add(minLqiFilter, 1, 2);

            gdpCapsLabel = new Label()
            {
                Text = "GDP Capabilities"
            };
            gdpCaps = new TextBox()
            {
                Tag = new rfdbConfigObject(32, Constants.profileFlags.ZRC20, 0, 0x00U, 0, 0)
            };
            gdpCaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(gdpCapsLabel, 0, 3);
            zrc20.Controls.Add(gdpCaps, 1, 3);

            pollConstsLabel = new Label()
            {
                Text = "Poll Constraints"
            };
            pollConsts = new TextBox()
            {
                Tag = new rfdbConfigObject(33, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)pollConsts.Tag).supported = false;
            pollConsts.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(pollConstsLabel, 0, 4);
            zrc20.Controls.Add(pollConsts, 1, 4);

            bindOrigValidTimeLabel = new Label()
            {
                Text = "Binding Originator Validation Time"
            };
            bindOrigValidTime = new TextBox()
            {
                Tag = new rfdbConfigObject(34, Constants.profileFlags.ZRC20, 0, 65000U, 0, 0)
            };
            bindOrigValidTime.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(bindOrigValidTimeLabel, 0, 5);
            zrc20.Controls.Add(bindOrigValidTime, 1, 5);

            idCapsLabel = new Label()
            {
                Text = "Identification Capabilities"
            };
            idCaps = new TextBox()
            {
                Tag = new rfdbConfigObject(35, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)idCaps.Tag).supported = false;
            idCaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(idCapsLabel, 0, 6);
            zrc20.Controls.Add(idCaps, 1, 6);

            zrcProCapsLabel = new Label()
            {
                Text = "ZRC Profile Capabilities"
            };
            zrcProCaps = new TextBox()
            {
                Tag = new rfdbConfigObject(36, Constants.profileFlags.ZRC20, 0, 0x01U, 0, 0)
            };
            zrcProCaps.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(zrcProCapsLabel, 0, 7);
            zrc20.Controls.Add(zrcProCaps, 1, 7);

            actBanksSuppTxLabel = new Label()
            {
                Text = "Action Banks Supported TX"
            };
            actBanksSuppTx = new TextBox()
            {
                Tag = new rfdbConfigObject(37, 32, 32, Constants.profileFlags.ZRC20, null, Utilities.CreateSpecialByteArray(32, 0x00), null, null)
            };
            ((rfdbConfigObject)actBanksSuppTx.Tag).zrc20Def[0] = 0x01;
            actBanksSuppTx.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(actBanksSuppTxLabel, 0, 8);
            zrc20.Controls.Add(actBanksSuppTx, 1, 8);

            numIrdbVendorsLabel = new Label()
            {
                Text = "Number of IRDB Vendors"
            };
            numIrdbVendors = new TextBox()
            {
                Tag = new rfdbConfigObject(38, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)numIrdbVendors.Tag).supported = false;
            numIrdbVendors.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(numIrdbVendorsLabel, 0, 9);
            zrc20.Controls.Add(numIrdbVendors, 1, 9);

            irdbVendorSuppLabel = new Label()
            {
                Text = "IRDB Vendor Support"
            };
            irdbVendorSupp = new TextBox()
            {
                Tag = new rfdbConfigObject(39, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)irdbVendorSupp.Tag).supported = false;
            irdbVendorSupp.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(irdbVendorSuppLabel, 0, 10);
            zrc20.Controls.Add(irdbVendorSupp, 1, 10);

            actBanksVerLabel = new Label()
            {
                Text = "Action Banks Version"
            };
            actBanksVer = new TextBox()
            {
                Tag = new rfdbConfigObject(40, Constants.profileFlags.ZRC20, 0, 0x0100, 0, 0)
            };
            actBanksVer.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(actBanksVerLabel, 0, 11);
            zrc20.Controls.Add(actBanksVer, 1, 11);

            actCodesSuppTxLabel = new Label()
            {
                Text = "Action Codes Supported TX"
            };
            actCodesSuppTx = new TextBox()
            {
                Tag = new rfdbConfigObject(41, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // To be assigned dynamically
            };
            ((rfdbConfigObject)actCodesSuppTx.Tag).supported = false;
            actCodesSuppTx.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(actCodesSuppTxLabel, 0, 12);
            zrc20.Controls.Add(actCodesSuppTx, 1, 12);

            numMapActsLabel = new Label()
            {
                Text = "Number of Mappable Actions"
            };
            numMapActs = new TextBox()
            {
                Tag = new rfdbConfigObject(42, Constants.profileFlags.ZRC20, 0, 0, 0, 0)
            };
            ((rfdbConfigObject)numMapActs.Tag).supported = false;
            numMapActs.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(numMapActsLabel, 0, 13);

            mapActsLabel = new Label()
            {
                Text = "Mappable Actions"
            };
            mapActs = new TextBox()
            {
                Tag = new rfdbConfigObject(43, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // To be assigned dynamically
            };
            ((rfdbConfigObject)mapActs.Tag).supported = false;
            mapActs.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(mapActsLabel, 0, 14);
            zrc20.Controls.Add(mapActs, 1, 14);

            numHaInstLabel = new Label()
            {
                Text = "Number of HA Instances"
            };
            numHaInst = new TextBox()
            {
                Tag = new rfdbConfigObject(44, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)numHaInst.Tag).supported = false;
            numHaInst.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(numHaInstLabel, 0, 15);
            zrc20.Controls.Add(numHaInst, 1, 15);

            haSuppLabel = new Label()
            {
                Text = "Home Automation Support"
            };
            haSupp = new TextBox()
            {
                Tag = new rfdbConfigObject(45, Constants.profileFlags.ZRC20, 0, 0, 0, 0)  // Not supported by Qorvo
            };
            ((rfdbConfigObject)haSupp.Tag).supported = false;
            haSupp.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20.Controls.Add(haSuppLabel, 0, 16);
            zrc20.Controls.Add(haSupp, 1, 16);
            zrc20.Controls.Add(numMapActs, 1, 13);

            panel.Controls.Add(zrc20Label, 1, 0);
            panel.Controls.Add(zrc20, 1, 1);

            ////////////////////////////////////////////////////////////////////
            // MSO-only parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            msoLabel = new Label()
            {
                Text = "MSO Only",
                TextAlign = ContentAlignment.MiddleLeft
            };
            msoLabel.Font = new Font(msoLabel.Font, FontStyle.Bold);

            mso = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "msoParams",
                RowCount = 4,
                Margin = new Padding(3, 0, 3, 0)
            };
            mso.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            mso.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            for (int i = 0; i < 4; i++)
            {
                mso.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            }

            // 4 parameters will populate this group's layout panel, each with a label and a text box
            respWaitTimeLabel = new Label()
            {
                Text = "Response Wait Time"
            };
            respWaitTime = new TextBox()
            {
                Tag = new rfdbConfigObject(47, Constants.profileFlags.MSO, 0, 0, 100U, 0)
            };
            respWaitTime.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            mso.Controls.Add(respWaitTimeLabel, 0, 0);
            mso.Controls.Add(respWaitTime, 1, 0);

            bindCfgLabel = new Label()
            {
                Text = "Binding Configuration"
            };
            bindCfg = new TextBox()
            {
                Tag = new rfdbConfigObject(48, Constants.profileFlags.MSO, 0, 0, 0x01, 0)
            };
            bindCfg.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            mso.Controls.Add(bindCfgLabel, 0, 1);
            mso.Controls.Add(bindCfg, 1, 1);

            bindInitIndLabel = new Label()
            {
                Text = "Binding Initiator Indication"
            };
            bindInitInd = new TextBox()
            {
                Tag = new rfdbConfigObject(49, Constants.profileFlags.MSO, 0, 0, 0x01, 0)
            };
            bindInitInd.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            mso.Controls.Add(bindInitIndLabel, 0, 2);
            mso.Controls.Add(bindInitInd, 1, 2);

            getValCfgLabel = new Label()
            {
                Text = "Get Validation Configuration"
            };
            getValCfg = new TextBox()
            {
                Tag = new rfdbConfigObject(50, Constants.profileFlags.MSO, 0, 0, 0x01, 0)
            };
            getValCfg.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            mso.Controls.Add(getValCfgLabel, 0, 3);
            mso.Controls.Add(getValCfg, 1, 3);

            panel.Controls.Add(msoLabel, 1, 2);
            panel.Controls.Add(mso, 1, 3);

            ////////////////////////////////////////////////////////////////////
            // MSO & ZRC2.0 parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            zrc20MsoLabel = new Label()
            {
                Text = "ZRC2.0 or MSO",
                TextAlign = ContentAlignment.MiddleLeft
            };
            zrc20MsoLabel.Font = new Font(zrc20MsoLabel.Font, FontStyle.Bold);

            zrc20Mso = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "zrc20MsoParams",
                RowCount = 3,
                Margin = new Padding(3, 0, 3, 0)
            };
            zrc20Mso.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            zrc20Mso.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            for (int i = 0; i < 3; i++)
            {
                zrc20Mso.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));
            }

            // 3 parameters will populate this group's layout panel, each with a label and a text box
            maxBindCandsLabel = new Label()
            {
                Text = "Maximum Binding Candidates"
            };
            maxBindCands = new TextBox()
            {
                Tag = new rfdbConfigObject(26, Constants.profileFlags.ZRC20_MSO, 0, 3, 3, 0)
            };
            maxBindCands.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20Mso.Controls.Add(maxBindCandsLabel, 0, 0);
            zrc20Mso.Controls.Add(maxBindCands, 1, 0);

            autoCheckValLabel = new Label()
            {
                Text = "Auto Check Validation Period"
            };
            autoCheckVal = new TextBox()
            {
                Tag = new rfdbConfigObject(27, Constants.profileFlags.ZRC20_MSO, 0, 500, 500, 0)
            };
            autoCheckVal.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20Mso.Controls.Add(autoCheckValLabel, 0, 1);
            zrc20Mso.Controls.Add(autoCheckVal, 1, 1);

            linkLostWaitTimeLabel = new Label()
            {
                Text = "Link Lost Wait Time"
            };
            linkLostWaitTime = new TextBox()
            {
                Tag = new rfdbConfigObject(28, Constants.profileFlags.ZRC20_MSO, 0, 5000, 10000, 0)
            };
            linkLostWaitTime.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            zrc20Mso.Controls.Add(linkLostWaitTimeLabel, 0, 2);
            zrc20Mso.Controls.Add(linkLostWaitTime, 1, 2);

            panel.Controls.Add(zrc20MsoLabel, 1, 4);
            panel.Controls.Add(zrc20Mso, 1, 5);

            ////////////////////////////////////////////////////////////////////
            // ESP-only parameters - define a group label and a group layout panel
            ////////////////////////////////////////////////////////////////////
            espLabel = new Label()
            {
                Text = "ESP",
                TextAlign = ContentAlignment.MiddleLeft
            };
            espLabel.Font = new Font(espLabel.Font, FontStyle.Bold);

            esp = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.InsetDouble,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "espParams",
                RowCount = 1,
                Margin = new Padding(3, 0, 3, 0)
            };
            esp.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            esp.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            esp.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 26));

            // Only 1 parameter will populate this group's layout panel, with a label and a text box
            tvNumLabel = new Label()
            {
                Text = "TV Number"
            };
            tvNum = new TextBox()
            {
                Tag = new rfdbConfigObject(51, Constants.profileFlags.ESP, 0, 0, 0, 1)
            };
            tvNum.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            esp.Controls.Add(tvNumLabel, 0, 0);
            esp.Controls.Add(tvNum, 1, 0);

            panel.Controls.Add(espLabel, 1, 6);
            panel.Controls.Add(esp, 1, 7);

            // A collection of labels that facilitates search and classification
            paramLabels = new List<Label>()
            {
                dstIeeeAddrLabel, appCapsLabel, devTypeListLabel, profileIDListLabel, destPanIDLabel, destNwkAddrLabel,
                rcuNodeCapsLabel, rcuVendorIDLabel, rcuVendorStringLabel, srchDevTypeLabel, discProfileIDListSizeLabel,
                discProfileIDListLabel, discDurationLabel, keyExchCntLabel, discRepIntLabel, maxDiscRepsLabel, maxRepNodesLabel,
                userStrLabel, keyRepIntLabel, numKeyMapsLabel, keyMapLabel, actPerLabel, dutyCycleLabel, irPairInfoLabel,
                discTimeoutLabel, maxDiscReportsLabel, maxBindCandsLabel, autoCheckValLabel, linkLostWaitTimeLabel, vendorIDFilterLabel,
                minMaxClassFilterLabel, minLqiFilterLabel, gdpCapsLabel, pollConstsLabel, bindOrigValidTimeLabel, idCapsLabel,
                zrcProCapsLabel, actBanksSuppTxLabel, numIrdbVendorsLabel, irdbVendorSuppLabel, actBanksVerLabel, actCodesSuppTxLabel,
                numMapActsLabel, mapActsLabel, numHaInstLabel, haSuppLabel, cmdDiscReqLabel, respWaitTimeLabel, bindCfgLabel,
                bindInitIndLabel, getValCfgLabel, tvNumLabel
            };
            // A collection of text boxes that facilitates search and classification
            paramBoxes = new List<TextBox>()
            {
                dstIeeeAddr, appCaps, devTypeList, profileIDList, destPanID, destNwkAddr, rcuNodeCaps, rcuVendorID, rcuVendorString,
                srchDevType, discProfileIDListSize, discProfileIDList, discDuration, keyExchCnt, discRepInt, maxDiscReps, maxRepNodes,
                userStr, keyRepInt, numKeyMaps, keyMap, actPer, dutyCycle, irPairInfo, discTimeout, maxDiscReports, maxBindCands,
                autoCheckVal, linkLostWaitTime, vendorIDFilter, minMaxClassFilter, minLqiFilter, gdpCaps, pollConsts, bindOrigValidTime,
                idCaps, zrcProCaps, actBanksSuppTx, numIrdbVendors, irdbVendorSupp, actBanksVer, actCodesSuppTx, numMapActs, mapActs,
                numHaInst, haSupp, cmdDiscReq, respWaitTime, bindCfg, bindInitInd, getValCfg, tvNum
            };

            foreach (var lbl in paramLabels)
            {
                lbl.AutoSize = true;
            }
            foreach (var box in paramBoxes)
            {
                box.Dock = System.Windows.Forms.DockStyle.Fill;
            }

            // The usual 'Ok' and 'Cancel' window buttons
            ok = new Button()
            {
                Anchor = AnchorStyles.None,
                Text = "Ok"
            };
            ok.Click += (sender, e) =>
            {
                ulong flags = 0x00;
                ulong mask = 0x01;
                // dstIeeeAddr is only supported when we're doing a Set Config command, as set/cleared by RfdbDialogBox()
                bool setConfig = ((rfdbConfigObject)dstIeeeAddr.Tag).supported;
                if (setConfig)
                {
                    Uapi.msgPayloadLen = 11;    // We will add the first 11 bytes (slot index, length, flags) after the loop
                }
                else
                {
                    Uapi.msgPayloadLen = 10;    // We will add the first 10 bytes (length, flags) after the loop
                }

                foreach (var box in paramBoxes)
                {
                    rfdbConfigObject cfg = (rfdbConfigObject)box.Tag;
                    if (cfg.changed || cfg.required)
                    {
                        cfg.changed = false;
                        flags |= mask;
                        Array.Copy(cfg.value, 0, Uapi.msgPayload, Uapi.msgPayloadLen, cfg.len);
                        Uapi.msgPayloadLen += (ushort)cfg.len;
                    }
                    mask <<= 1;
                }
                if (setConfig)
                {
                    Uapi.msgPayload[0] = ((rfdbConfigObject)slotIndex.Tag).value[0];
                    // Config data length, excluding itself & slot index
                    BitConverter.GetBytes(Uapi.msgPayloadLen - 3).CopyTo(Uapi.msgPayload, 1);
                    BitConverter.GetBytes(flags).CopyTo(Uapi.msgPayload, 3);
                    Uapi.SendMessage(0x13, 0x47);   // Set Config
                }
                else
                {
                    // Config data length, excluding itself
                    BitConverter.GetBytes(Uapi.msgPayloadLen - 2).CopyTo(Uapi.msgPayload, 0);
                    BitConverter.GetBytes(flags).CopyTo(Uapi.msgPayload, 2);
                    Uapi.SendMessage(0x13, 0x43);   // Start Discovery
                }
                rfdbBox.Close();
            };

            cancel = new Button()
            {
                Anchor = AnchorStyles.None,
                Text = "Cancel"
            };
            cancel.Click += (sender, e) =>
            {
                rfdbBox.Close();
            };

            panel.Controls.Add(ok, 1, 8);
            panel.Controls.Add(cancel, 0, 8);

            rfdbBox.Controls.Add(panel);

            slotBox = new Form();
            slotBox.Name = "slotBox";
            slotBox.Width = 150;
            slotBox.Height = 150;
            slotBox.Icon = Program.mf.Icon;
            slotBox.FormBorderStyle = FormBorderStyle.FixedDialog;
            slotBox.MaximizeBox = false;
            slotBox.MinimizeBox = false;
            slotBox.Text = "Specify Target Slot Index";

            slotPanel = new TableLayoutPanel()
            {
                CellBorderStyle = TableLayoutPanelCellBorderStyle.None,
                ColumnCount = 2,
                Dock = System.Windows.Forms.DockStyle.Fill,
                Name = "slotIndex",
                RowCount = 2
            };

            slotPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            slotPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            slotPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.AutoSize));
            slotPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.AutoSize));

            // Only 1 parameter will populate this group's layout panel, with a label and a text box
            slotIndexLabel = new Label()
            {
                AutoSize = true,
                Text = "Slot Index",
                TextAlign = ContentAlignment.BottomRight
            };
            slotIndex = new TextBox()
            {
                Dock = System.Windows.Forms.DockStyle.Fill,
                Tag = new rfdbConfigObject(0xFF, Constants.profileFlags.COMMON, 0, 0, 0, 0)
            };
            ((rfdbConfigObject)slotIndex.Tag).value = new byte[1] { 0 };
            slotIndex.Text = "00";
            slotIndex.KeyUp += new System.Windows.Forms.KeyEventHandler(SaveValue);
            slotPanel.Controls.Add(slotIndexLabel, 0, 0);
            slotPanel.Controls.Add(slotIndex, 1, 0);

            slotOk = new Button()
            {
                Anchor = AnchorStyles.None,
                Text = "Ok",
                DialogResult = DialogResult.OK
            };
            slotOk.Click += (sender, e) =>
            {
                ((rfdbConfigObject)slotIndex.Tag).value =
                    Utilities.HexStringToByteArray(slotIndex.Text, ((rfdbConfigObject)slotIndex.Tag).len);
            };

            slotCancel = new Button()
            {
                Anchor = AnchorStyles.None,
                Text = "Cancel",
                DialogResult = DialogResult.Cancel
            };

            slotPanel.Controls.Add(slotOk, 1, 1);
            slotPanel.Controls.Add(slotCancel, 0, 1);

            slotBox.Controls.Add(slotPanel);
        }

        public static DialogResult RfdbGetSlot()
        {
            return slotBox.ShowDialog();
        }

        public static void RfdbDialogBox(bool setConfig)
        {
            rfdbBox.Text = string.Format("Parameters for {0}", setConfig ? "Set Configuration" : "Start Discovery");

            ((rfdbConfigObject)discTimeout.Tag).supported = !setConfig;
            ((rfdbConfigObject)maxDiscReports.Tag).supported = !setConfig;
            ((rfdbConfigObject)dstIeeeAddr.Tag).supported = setConfig;

            UpdateParamControls();

            rfdbBox.ShowDialog();
        }

        private static void SaveValue(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                TextBox box = (TextBox)sender;
                rfdbConfigObject cfg = (rfdbConfigObject)box.Tag;
                byte[] bytes = Utilities.HexStringToByteArray(box.Text, (cfg.maxLen == 0) ? cfg.len : cfg.maxLen);

                cfg.changed = !bytes.Equals(cfg.value);
                if (cfg.changed)
                {
                    cfg.value = bytes;
                    box.Text = Utilities.ByteArrayToHexString(bytes);
                    if (cfg.maxLen != 0)
                    {
                        cfg.len = 0;
                        for (int i = 0; i < cfg.maxLen; i++)
                        {
                            if (bytes[i] != 0)
                            {
                                bytes[cfg.len++] = bytes[i];
                            }
                        }
                    }
                }
            }
        }

        private static void SaveStringValue(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                TextBox box = (TextBox)sender;
                rfdbConfigObject cfg = (rfdbConfigObject)box.Tag;

                if (cfg.idx == 8)   // Vendor string
                {
                    cfg.len = 7;
                }
                else if (cfg.idx == 17) // User string
                {
                    if (profileID.Equals(Constants.profileFlags.ZRC20))
                    {
                        cfg.len = 8;
                    }
                    else if (profileID.Equals(Constants.profileFlags.MSO))
                    {
                        cfg.len = 9;
                    }
                    else
                    {
                        cfg.len = 15;
                    }
                }
                else
                {
                    // Invalid...or future string parameter...?
                    return;
                }

                byte[] bytes = Utilities.CreateSpecialByteArray(cfg.len, 0x00);

                // If the input string starts with an apostrophe, it should be interpreted as a regular character string
                if (box.Text.IndexOf("\'") == 0)
                {
                    byte[] unicodeBytes = Encoding.Unicode.GetBytes(box.Text.Substring(1));
                    byte[] asciiBytes = Encoding.Convert(Encoding.Unicode, Encoding.ASCII, unicodeBytes);
                    if (asciiBytes.Length > cfg.len)
                    {
                        Array.Copy(asciiBytes, bytes, cfg.len);
                    }
                    else
                    {
                        Array.Copy(asciiBytes, bytes, asciiBytes.Length);
                    }
                }
                else
                {
                    bytes = Utilities.HexStringToByteArray(box.Text, cfg.len);
                }

                cfg.changed = !bytes.Equals(cfg.value);
                if (cfg.changed)
                {
                    cfg.value = bytes;
                    box.Text = Utilities.ByteArrayToHexString(bytes);
                }
            }
        }

        private static void SaveProfileValue(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                int i;
                TextBox box = (TextBox)sender;
                rfdbConfigObject cfg = (rfdbConfigObject)box.Tag;
                byte[] bytes = Utilities.HexStringToByteArray(box.Text, cfg.maxLen);

                int numProfiles = 0;
                Constants.profileFlags found = 0;

                for (i = 0; i < bytes.Length; i++)
                {
                    if (bytes[i] != 0)
                    {
                        bytes[numProfiles++] = bytes[i];
                        try
                        {
                            found |= Constants.profiles[bytes[i]];
                        }
                        catch (KeyNotFoundException)
                        {
                            box.Text = Utilities.ByteArrayToHexString(cfg.value);
                            return;
                        }
                    }
                }
                for (i = numProfiles; i < bytes.Length; i++)
                {
                    bytes[i] = 0x00;
                }

                if (numProfiles == 1)
                {
                    profileID = Constants.profiles[bytes[0]];
                }
                else if ( (numProfiles == 2) && found.Equals(Constants.profileFlags.ZRC11_ZRC20) )
                {
                    profileID = Constants.profileFlags.ZRC20;
                }
                else if ( ((numProfiles == 2) &&
                           (found.Equals(Constants.profileFlags.MSO_MSO_VOICE) || found.Equals(Constants.profileFlags.MSO_MSO_OTA))) ||
                          ((numProfiles == 3) && found.Equals(Constants.profileFlags.MSO_MSO_VOICE_OTA)) )
                {
                    profileID = Constants.profileFlags.MSO;
                }
                else
                {
                    // Invalid entry! Restore default text and exit.
                    box.Text = Utilities.ByteArrayToHexString(cfg.value);
                    return;
                }

                cfg.len = numProfiles;
                cfg.changed = !bytes.Equals(cfg.value);
                if (cfg.changed)
                {
                    cfg.value = bytes;
                    box.Text = Utilities.ByteArrayToHexString(bytes);
                }
                UpdateParamControls();
            }
        }

        private static void UpdateParamControls()
        {
            rfdbConfigObject cfg;
            int controlIndex = 0;

            foreach (var box in paramBoxes)
            {
                box.Enabled = false;
                paramLabels[controlIndex].Enabled = false;
                cfg = (rfdbConfigObject)box.Tag;
                if (cfg.profiles.HasFlag(profileID))
                {
                    if (!cfg.changed)
                    {
                        cfg.value = GetProfileDefaults(cfg);
                        box.Text = Utilities.ByteArrayToHexString(cfg.value);
                    }
                    if (cfg.supported)
                    {
                        box.Enabled = true;
                        paramLabels[controlIndex].Enabled = true;
                    }
                }
                ++controlIndex;
            }
        }

        private static byte[] GetProfileDefaults(rfdbConfigObject tag)
        {
            if (profileID.Equals(Constants.profileFlags.ZRC11))
            {
                return tag.zrc11Def;
            }
            if (profileID.Equals(Constants.profileFlags.ZRC20))
            {
                return tag.zrc20Def;
            }
            if (profileID.Equals(Constants.profileFlags.MSO))
            {
                return tag.msoDef;
            }
            if (profileID.Equals(Constants.profileFlags.ESP))
            {
                return tag.espDef;
            }
            // This has not been implemented yet!
            if (profileID.Equals(Constants.profileFlags.ZID))
            {
                return tag.zrc11Def;
            }
            // If this point is reached, we have a bug elsewhere...
            return null;
        }
    }
}
